<?php

namespace App\Controller;

use App\Entity\Film;
use App\Form\FilmType;
use App\Repository\FilmRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Attribute\Route;

class IndexController extends AbstractController
{
    #[Route('/{id?}', name: 'app_index', methods: ['GET', 'POST'], requirements: ['id' => '\d+'])]
    public function index(Request $request, FilmRepository $filmRepository, ?Film $film = null): Response
    {
        $film = $film ?? new Film();
        $form = $this->createForm(FilmType::class, $film);
        $films = $filmRepository->findAll();

        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $filmRepository->save($film, true);

            return $this->redirectToRoute('app_index', [], RedirectResponse::HTTP_SEE_OTHER);
        }

        return $this->render('index/index.html.twig', [
            'films' => $films,
            'form' => $form
        ]);
    }

    #[Route('/update-order', name: 'update_order', methods: ['POST'])]
    public function updateOrder(Request $request): Response
    {
        $order = json_decode($request->getContent(), true)['order'];
        dump($order);

        return new Response('Order updated', Response::HTTP_OK);
    }
}
